# Code on Sliding Mode Observer Based Detection of MITM Attacks In CVPs
Sliding mode observers (SMOs) have been proposed for exact anomaly estimation for a class of ideal systems without unmatched uncertainties and measurement noise. For such ideal systems anomaly detection is trivial, however for systems with unmatched uncertainties or measurement noise a dedicated detector is needed. In this code two of such robust anomaly detectors are implemented, which extend the anomaly detection capability of a large class of SMOs to include systems with unmatched uncertainties and measurement noise. The first detector is based on the so-called equivalent output injection (EOI), which is closely related to the anomaly estimate. The second detector is directly based on the SMO state estimation error. Doing so, the second detector bypasses the low-pass filter generating the EOI allowing for faster detection of anomalies and making it possible to detect smaller magnitude anomalies. The detectors are applied in this code to detect a man-in-the-middle (MITM) attack on a collaborative vehicle platoon (CVP).

The code used to generate results presented in chapter 2 of the PhD dissertation of Twan Keijzer: Advances in Safety and Security of Cyber-Physical Systems - Sliding Mode Observers, Coalitional Control and Homomorphic Encryption

## Files
Simulation_Main.m - run this file, it calls all other files in the folder. 
set_CACC_nocontrol.m - defines the vehicle models and a controller (controller can be changed without affecting the detectors)
CACC_nocontrol.slx - simulink model that performs the actual simulation of the platoon and detectors.